/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package testjpa.univ;

import java.util.HashSet;
import java.util.Set;
import javax.persistence.*;

/**
 *
 * @author rosmord
 */
@Entity
public class Course {
    @Id
    @GeneratedValue(strategy= GenerationType.IDENTITY)
    @Column(name="COURSE_ID")
    private Long id;
    
    private String title="";
    
    @ManyToOne
    private Professor professor= null;
    
    @ManyToOne
    private StudentGroup studentGroup= null;
    
    @ManyToMany    
    @JoinTable(
            joinColumns=@JoinColumn(name="COURSE_ID"),
            inverseJoinColumns=@JoinColumn(name="COURSEDOMAIN_ID")
    )
    private Set<CourseDomain> courseDomains= new HashSet();
    
    public Course() {        
    }
    
    public Course(String title, Professor professor, StudentGroup studentGroup) {
        this.title= title;
        this.professor= professor;
        this.studentGroup= studentGroup;
    }
    
    public void addDomain(CourseDomain courseDomain) {
        if (courseDomains.add(courseDomain)) {
            courseDomain.addCourse(this);
        }
    }
    
    public void removeDomain(CourseDomain courseDomain) {
        if (courseDomains.remove(courseDomain)) {
            courseDomain.removeCourse(this);
        }
    }

    @Override
    public String toString() {
        return "Course{" + "id=" + id + ", title=" + title + ", professor=" + professor + ", studentGroup=" + studentGroup + ", courseDomains=" + courseDomains + '}';
    }
 
    
}
