/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package testjpa.univ;

import java.io.Serializable;
import java.util.Collections;
import java.util.HashSet;
import java.util.Set;
import javax.persistence.*;

/**
 *
 * @author rosmord
 */
@Entity
public class StudentGroup implements Serializable {
    @Id
    @GeneratedValue(strategy= GenerationType.IDENTITY)
    @Column(name="STUDENT_GROUP_ID")
    private Long id= null;    
    private String groupName="";
    
    @OneToMany(mappedBy="studentGroup")
    private Set<Student> students= new HashSet<Student>();

    public StudentGroup() {
    }

    public StudentGroup(Long id, String groupName) {
        this.id = id;
        this.groupName = groupName;
    }

    public String getGroupName() {
        return groupName;
    }

    public void setGroupName(String groupName) {
        this.groupName = groupName;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }
    
    public void addStudent(Student e) {
        if (e.getStudentGroup() == this) return;
        if (e.getStudentGroup() != null) {
            e.getStudentGroup().removeStudent(e);
        }
        students.add(e);
        e.setStudentGroup(this);
    }

    public void removeStudent(Student e) {
        e.setStudentGroup(null);
        students.remove(e);
    }

    public Set<Student> getStudents() {
        return Collections.unmodifiableSet(students);
    }

    @Override
    public String toString() {
        return "StudentGroup{" + "id=" + id + ", groupName=" + groupName + '}';
    }
    
    
    
}
